<cfimport prefix="g" taglib="../../groovyEngine/tags" />

<!---
Again, we have an application-scoped runtime, this time with a groovy
path configured.
--->

<cfscript>
a = [];
month = createDate(year(now()), month(now()), 1);
for (i = 1; i LTE 6; i = i + 1) {
	s = {
		letter = chr(65 + randRange(0, 25)),
		date = dateAdd("d", randRange(0, 27), month)
	};
	arrayAppend(a, s);
}
</cfscript>

<h1>Comparators</h1>

<p>Here we're doing some sorting of complex values using Java <code>Comparator</code>s.
An array of six structs is created, each with a random letter and random date inside.  That's
what's dumped in the first column.  The rest of the columns show the same array sorted in 
different ways.
</p>

<cfif structKeyExists(server, "railo") AND server.railo["release-date"] LTE createDate(2008, 6, 27)>
	<p><strong style="color:red;">On Railo 3.0.0.002 and below only</strong>, no sorting happens.  There is
	<a href="http://jira.jboss.org/jira/browse/RAILO-31">a bug (which has been resolved)</a> that prevents
	<code>Collections.sort</code> from making changes to the array being sorted.  Later versions of Railo
	do not have this problem.
	</p>
</cfif>

<table>
<tr>
	<th>Randomized</th>
	<th>Letter (CFML)</th>
	<th>Letter (closure)</th>
	<th>Date DESC (class)</th>
</tr>
<tr>
<td>
<cfdump var="#a#" />
</td>
<td>
	<cfset myArray = a />
	<cfset keys = "" />
	<cfloop from="1" to="#arrayLen(myArray)#" index="i">
		<cfset keys = listAppend(keys, myArray[i].letter & "~" & i) />
	</cfloop>
	<cfset newArray = [] />
	<cfloop list="#listSort(keys, 'textNoCase')#" index="key">
		<cfset arrayAppend(newArray, myArray[listLast(key, "~")]) />
	</cfloop>
	<cfdump var="#newArray#" />
</td>
<td>
<g:script>
Collections.sort(variables.a, {o1, o2 ->
	o1.letter.compareTo(o2.letter)
} as Comparator)
</g:script>
<cfdump var="#a#" />
</td>
<td>
<g:script>
Collections.sort(variables.a, new ReverseDateKeyComparator())
</g:script>
<cfdump var="#a#" />
</td>
</tr>
</table>
