package com.barneyb.cfgroovy.hibernate

import java.sql.Connection

import org.hibernate.*
import org.hibernate.cfg.*
import org.hibernate.connection.*

class DataSourceConnectionProvider implements ConnectionProvider {
	
	static ThreadLocal dataSourceHolder = new ThreadLocal()
	
	def dataSource
	
	def DataSourceConnectionProvider() {
        this.dataSource = DataSourceConnectionProvider.dataSourceHolder.get()
		if (! this.dataSource) {
		    throw new IllegalStateException("The dataSourceHolder was empty - it MUST contain a DataSource instance to use")
		}
	}

	void close() {
		// no op
	}
	
	void closeConnection(Connection conn) {
		conn.close()
	}
	
	void configure(Properties props) {
		// no op
	}
	
	Connection getConnection() {
		dataSource.getConnection()
	}
	
	boolean supportsAggressiveRelease() {
		false
	}
	
}