<cfsilent>
<!---
This tag executes either a named Groovy script, or it's body content as
an unnamed Groovy script.  It uses a CF Groovy runtime either passed to
it's 'cfgroovy' attribute or stored in the 'application.cfgroovy'
variable.  For backwards compatibility, it also will check
'request.__cf_groovy_runtime__', though this is deprecated.

See the docs for cfgroovy.cfc for details on the environment the script
will execute within.
--->
<cfif thisTag.executionMode EQ "start">
	<cftry>
		<cfinclude template="../act_locatecfgroovy.cfm" />
		<cfcatch type="CFGroovy.NoRuntimeFoundException">
			<cfmodule template="setPath.cfm" />
			<cfinclude template="../act_locatecfgroovy.cfm" />
		</cfcatch>
	</cftry>
	<cfif structKeyExists(attributes, "variables")>
		<cfset variablesScope = attributes.variables />
	<cfelse>
		<cfset variablesScope = caller />
	</cfif>
	<cfif structKeyExists(attributes, "name")>
		<cfset runtime.runScript(attributes.name, variablesScope) />
		<cfexit method="exittag" />
	<cfelseif structKeyExists(attributes, "script")>
		<cfset runtime.runScriptBody(attributes.script, variablesScope) />
		<cfexit method="exittag" />
	<cfelseif NOT thistag.hasEndTag>
		<cfthrow type="IllegalStateException"
			message="The g:script must have a name attributes, a script attribute, or a body containing a script to execute." />
	</cfif>
<cfelseif thisTag.executionMode EQ "end">
	<!--- get the script in the right spot, if needed --->
	<cfset theScript = trim(thisTag.generatedContent) />
	<cfset thisTag.generatedContent = "" />
	<cfif len(theScript) EQ 0>
		<cfthrow type="CFGroovy.EmptyScriptException"
			message="You attempted to execute an empty script.  This is not allowed"
			detail="Groovy scripts must have at least one expression in them.  Forgetting to use &lt;cfoutput> around your &lt;g:script> tag when &lt;cfsetting enableCfOutputOnly=""true"" /> is a common cause of this problem." />
	</cfif>
	<cfset runtime.runScriptBody(theScript, variablesScope) />
</cfif>
</cfsilent>